var qm = require('qminer');
var loader = require('qminer-data-loader@1.2.0');
'libraries loaded';

var base = new qm.Base({
  mode: 'createClean',
  schema: [{
    name: 'Visitors',
    fields: [{ name: 'ID', type: 'string', primary: true }],
    joins: [{ name: 'lectures', type: 'index', store: 'Lectures', inverse : 'visitors' }]
  }, {
    name: 'Lectures',
    fields: [{ name: 'Title', type: 'string', primary: true }],
    joins: [{ name: 'visitors', type: 'index', store: 'Visitors', inverse: 'lectures'}]
  }]
});
'defined schema';

loader.loadRecommendationDataset(base.store('Visitors'));
'Loaded ' + base.store('Lectures').length + ' visitors';

var john = base.store('Visitors')[126];
'Visitor ' + john.ID + ' viewed ' + john.lectures.length + ' lectures';
john.lectures[0].Title;

var coVisitors = john.lectures.join('visitors');
coVisitors.length + ' visitors watched at least one of the same lectures';

var coLectures = coVisitors.join('lectures', 1000);
'Co-visitors watched ' + coLectures.length + ' lectures';

var result = coLectures.setDiff(john.lectures);
result.sortByFq(-1).trunc(5);
'Recommendations generated';

result[0].Title;
result[1].Title;